summaryrefslogtreecommitdiff
path: root/helpers/binary_local-packageslists
diff options
context:
space:
mode:
authorDaniel Baumann <daniel@debian.org>2010-02-05 17:10:44 +0100
committerDaniel Baumann <daniel@debian.org>2011-03-09 19:17:04 +0100
commit3b80c5c5d9c9d2eec91910b70a120da5943c7fac (patch)
tree31b5fef2977e7fabe669077041c569169c788a95 /helpers/binary_local-packageslists
parent59e9a93ad08c171fb0d22e965c56f91c5bd17615 (diff)
downloadlive-build-3b80c5c5d9c9d2eec91910b70a120da5943c7fac.zip
live-build-3b80c5c5d9c9d2eec91910b70a120da5943c7fac.tar.gz
Dropping lh_ prefix from internal helpers, this is not user visible.
Diffstat (limited to 'helpers/binary_local-packageslists')
-rwxr-xr-xhelpers/binary_local-packageslists110
1 files changed, 110 insertions, 0 deletions
diff --git a/helpers/binary_local-packageslists b/helpers/binary_local-packageslists
new file mode 100755
index 0000000..43d8005
--- /dev/null
+++ b/helpers/binary_local-packageslists
@@ -0,0 +1,110 @@
+#!/bin/sh
+
+# lh_binary_local-packageslists(1) - install local packages lists into binary
+# Copyright (C) 2006-2009 Daniel Baumann <daniel@debian.org>
+#
+# live-helper comes with ABSOLUTELY NO WARRANTY; for details see COPYING.
+# This is free software, and you are welcome to redistribute it
+# under certain conditions; see COPYING for details.
+
+set -e
+
+# Including common functions
+. "${LH_BASE:-/usr/share/live-helper}"/live-helper.sh
+
+# Setting static variables
+DESCRIPTION="$(Echo 'install local packages into binary')"
+HELP=""
+USAGE="${PROGRAM} [--force]"
+
+Arguments "${@}"
+
+# Reading configuration files
+Read_conffiles config/all config/common config/bootstrap config/chroot config/binary config/source
+Set_defaults
+
+Echo_message "Begin installing local packages lists..."
+
+# Requiring stage file
+Require_stagefile .stage/config .stage/bootstrap
+
+# Checking stage file
+Check_stagefile .stage/binary_local-packageslists
+
+# Checking lock file
+Check_lockfile .lock
+
+# Creating lock file
+Create_lockfile .lock
+
+if Find_files config/binary_local-packageslists/*
+then
+ # Restoring cache
+ Restore_cache cache/packages_chroot
+
+ # Check depends
+ Check_package chroot/usr/bin/apt-ftparchive apt-utils
+
+ # Installing depends
+ Install_package
+
+ mkdir -p chroot/binary.deb/archives/partial
+ mv chroot/var/lib/dpkg/status chroot/var/lib/dpkg/status.tmp
+ touch chroot/var/lib/dpkg/status
+
+ for PACKAGESLIST in config/binary_local-packageslists/*
+ do
+ # Generate package list
+ Expand_packagelist "${PACKAGESLIST}" "config/binary_local-packageslists" "config/chroot_local-packageslists" > chroot/root/"$(basename ${PACKAGESLIST})"
+
+ # Downloading additional packages
+ Chroot chroot "xargs --arg-file=/root/$(basename ${PACKAGESLIST}) apt-get ${APT_OPTIONS} -o Dir::Cache=/binary.deb --download-only install"
+
+ # Remove package list
+ rm chroot/root/"$(basename ${PACKAGESLIST})"
+ done
+
+ for FILE in chroot/binary.deb/archives/*.deb
+ do
+ SOURCE="$(dpkg -f ${FILE} Source | awk '{ print $1 }')"
+
+ if [ -z "${SOURCE}" ]
+ then
+ SOURCE="$(basename ${FILE} | awk -F_ '{ print $1 }')"
+ fi
+
+ case "${SOURCE}" in
+ lib?*)
+ LETTER="$(echo ${SOURCE} | sed 's|\(....\).*|\1|')"
+ ;;
+
+ *)
+ LETTER="$(echo ${SOURCE} | sed 's|\(.\).*|\1|')"
+ ;;
+ esac
+
+ # Install directory
+ mkdir -p binary/pool/main/"${LETTER}"/"${SOURCE}"
+
+ # Move files
+ mv "${FILE}" binary/pool/main/"${LETTER}"/"${SOURCE}"
+ done
+
+ cd binary
+ mkdir -p dists/${LH_DISTRIBUTION}/main/binary-${LH_ARCHITECTURE}
+ apt-ftparchive packages pool/main > dists/${LH_DISTRIBUTION}/main/binary-${LH_ARCHITECTURE}/Packages
+ gzip -9 -c dists/${LH_DISTRIBUTION}/main/binary-${LH_ARCHITECTURE}/Packages > dists/${LH_DISTRIBUTION}/main/binary-${LH_ARCHITECTURE}/Packages.gz
+ cd "${OLDPWD}"
+
+ rm -rf chroot/binary.deb
+ mv chroot/var/lib/dpkg/status.tmp chroot/var/lib/dpkg/status
+
+ # Removing depends
+ Remove_package
+
+ # Saving cache
+ Save_cache cache/packages_chroot
+
+ # Creating stage file
+ Create_stagefile .stage/binary_local-packageslists
+fi